//+------------------------------------------------------------------+
//|                                                    ATR_Bands.mq4 |
//| ATR Bands are self-adjusting enveloppes, based on the volatility |
//|        Based on BB indicator, modified by kris.pivo[at]gmail.com |
//+------------------------------------------------------------------+
#property copyright " 2008, Kris"
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 Red
#property indicator_color3 LimeGreen
//---- indicator parameters
extern double Alpha                = 0.07;
extern int    NumberOfComputations = 2;
extern int    NumberOfBars         = 1000;
extern int    Price                = PRICE_MEDIAN;
extern int    ATR_Period           = 4;
//extern int    T3_Period            = 20;
extern double b                    = 1.00;
extern double ATR_Multiplier       = 2;
extern double timefactor           = 1;// 1=timeframe used, if higher tf for instance on 1hr chart want h4 band timefactor should =4 
//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];
int    Lag; 
int    T3_Period; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle( 0,DRAW_LINE,STYLE_DASH,1,indicator_color1);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle( 1,DRAW_LINE,STYLE_DASH,1,indicator_color2);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle( 2,DRAW_LINE,STYLE_DASH,1,indicator_color3);
   SetIndexBuffer(2,LowerBuffer);
//----
   SetIndexDrawBegin(0,Lag);
   SetIndexDrawBegin(1,Lag);
   SetIndexDrawBegin(2,Lag);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double TrueRange;
   double sum,oldval,newres;
   Lag = iCustom(NULL,0,"CyclePeriod",Alpha,0,i)/2*timefactor;
   T3_Period = iCustom(NULL,0,"CyclePeriod",Alpha,0,i)/2*timefactor; 
//----
   if(Bars<=Lag) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=Lag;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
   MovingBuffer[i]=iCustom(NULL,0,"SSAofprice",Lag,NumberOfComputations,NumberOfBars,Price,0,i);
//----
   i=Bars-Lag+1;
   if(counted_bars>Lag-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+Lag-1;
      oldval=MovingBuffer[i];
      TrueRange=ATR_Multiplier*iCustom(NULL,0,"ATR_T3_v1.1",ATR_Period,T3_Period,b,false,0,i);
      UpperBuffer[i]=oldval+TrueRange;
      LowerBuffer[i]=oldval-TrueRange;
      i--;
     }
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//                                       THE END                                        |
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

